unit UnitStwor000;
interface
uses OmegaImageList,OmegaSprite,unit1,Sysutils;
type
tKierunek=(kierN,kierNE,kierE,kierSE,kierS,kierSW,kierW,kierNW);
TStwor=class(TSprite)
 private
   staryKierunek,

   dVA      :single;   //predkoc wykonywania animacji
   ofsetKlatki   :byte;//przesuniecie klatek animacji zalezne od kierunku ruchu
   Skok_X,
   Skok_Y:single;
   BufordV    :single;//zapamietuje aktualna predkosc
   StareX,
   StareY:single;
   fWBudynku:boolean;
   stareKD,stareWD,
   kD,wD,
   k,w:integer;//indeks kolumny i wiersza
   function  kierunekN (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekS (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekW (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekE (const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekNW(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekSW(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekNE(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   function  kierunekSE(const V:Single):tKierunek;//zwroci nowy kierunek jak kolizja
   procedure Odbicie;
   procedure MoznaIsc(const Value:single);
 public
    kierunek :tKierunek;
    fPokryty:boolean;//czc czwarta    fPokryty,
    fKolizja:boolean;
    IDAnimacji:single;//licznik animacji
   function  Pokryty(x0,y0,_width,_height:single):boolean;
   procedure JakaKostka;

   constructor Create(const AParent: TOmegaSprite;
                      const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                      const IdKlatka:Integer//indeks wycinanej klatki
                      );
   function  KierunekPoKolizji(const colX,colY:integer):tKierunek;
   procedure onCollision(const Sprite:Tsprite;const colX,colY:integer);override;
   procedure Move(const MoveCount:single);override;
   procedure Draw;override;
end;

procedure TworzBorostwora( const Ax,Ay:integer;
                           const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                           const IdKlatka:Integer//indeks wycinanej klatki);
                          );
var
 Borostwor: TStwor;

implementation

//********Poczatek klasy TSwtor*********
function TStwor.KierunekPoKolizji(const colX,colY:integer):tKierunek;
  var
    s,h:integer;
    kwadrat,K,W:byte;//kolumna i wierzs kwadratu zderzenia
  begin
    s:=Image.TileWidth  div 2;//wyznacz polowy z serokoci i wysokosci klatki
    h:=Image.TileHeight div 2;
    k:=colX div s;//podziel na kolumny iwiersze
    w:=colY div h;
    kwadrat:=k+w*2;//oblicz kawdrat zderzenia
    case kwadrat of
      0:result:=kierNE;//na podstwaie kawdratu zderzenia wyznacz kierunek odbicia
      1:result:=kierNW;
      2:result:=kierSE;
      3:result:=kierSW;
    end;
  end;

constructor TStwor.Create(const AParent: TOmegaSprite;
                          const ImageListItem: TImageListItem;
                          const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image        := ImageListItem;
 ImageIndex   :=idKlatka;
 width        :=Image.TileWidth;
 height       :=Image.TileHeight;
 DoCollision  :=true;
 DoPixelCheck :=true;
 fWBudynku    :=false;
 fKolizja     :=false;
end;

procedure TStwor.JakaKostka;
begin
 //zapamietaj stara kostek tablicy drogi
 stareKD:=kD;
 stareWD:=wD;
 //policz kol i wiersz w tablicy drog
 kd:=Round(x-Warstwa0[0,0].x+Image.TileWidth  div 2) div 32;
 wd:=Round(y-Warstwa0[0,0].y+Image.TileHeight div 2) div 32;
 if kd<0 then kd:=0;
 if kd>High(Drogi[0]) then kd:=high(drogi[0]);
 if wd<0 then wd:=0;
 if wd>High(Drogi) then wd:=high(drogi);

 //policz kol i wiersz w swiecie warstw i wyznacz Z
 k:=Round(x-Warstwa0[0,0].x+Image.TileWidth  div 2)div Warstwa0[0,0].Image.TileWidth;
 w:=Round(y-Warstwa0[0,0].y+Image.TileHeight div 2)div Warstwa0[0,0].Image.TileHeight;

 if k< 0 then k:=0;
 if k>19 then k:=19;
 if w< 0 then w:=0;
 if w>19 then w:=19;
 z:=w+3;
 //*****cz czwarta************
 if (k=9)and(w=14)and(not fWBudynku)then
    fWBudynku:=true;

 if (k=9)and(w=15)and(fWBudynku)then
    fWBudynku:=false;

end;
function  TStwor.Pokryty(x0,y0,_width,_height:single):boolean;
begin
 result:=false;
 if (x>X0)and
    (y+12>y0)and
    (x+Image.TileWidth<x0+_width)and
    (y+Image.TileHeight<y0+_height)
    then result:=true;
end;


function  TStwor.kierunekN (const V:Single):tKierunek;
begin
 Skok_Y:=-25*V;
 ofsetKlatki:=0;
 result:=kierN;
end;
function  TStwor.kierunekNW(const V:Single):tKierunek;
begin
 Skok_Y:=-25*V;
 Skok_X:=-25*V;
 ofsetKlatki:=0;
 result:=kierNW;
end;
function  TStwor.kierunekNE(const V:Single):tKierunek;
begin
 ofsetKlatki:=0;
 Skok_Y:=-25*V;
 Skok_X:=25*V;
 result:=kierNE;
end;

function  TStwor.kierunekS (const V:Single):tKierunek;
begin
 Skok_Y:=25*V;
 ofsetKlatki:=3;
 result:=kierS;
end;
function  TStwor.kierunekSW(const V:Single):tKierunek;
begin
 Skok_Y:=25*V;
 Skok_X:=-25*V;
 ofsetKlatki:=3;
 result:=kierSW;
end;
function  TStwor.kierunekSE(const V:Single):tKierunek;
begin

 Skok_X:=25*V;
 Skok_Y:=25*V;
 ofsetKlatki:=3;
 result:=kierSE;
end;
function  TStwor.kierunekW (const V:Single):tKierunek;
begin
 Skok_X:=-25*V;
 ofsetKlatki:=6;
 result:=kierW;
end;
function  TStwor.kierunekE (const V:Single):tKierunek;
begin
 Skok_X:=25*V;
 ofsetKlatki:=9;
 result:=kierE;
end;
procedure TStwor.onCollision(const Sprite:Tsprite;const colX,colY:integer);
begin
  if not Visible then exit;
  //kolizja z innym BOROSTWOREM- tu akcja odbij
  if (Sprite is TStwor)then begin
     if TStwor(Sprite).fKolizja then exit;
     fKolizja:=true;
     kierunek:=KierunekPoKolizji(colX,colY);
     dVa:=0;//prdko animacj na czas zderzenia wyzeruj;
     case kierunek of
      kierNW:begin x:=x-2;y:=y-2;end;
      kierNE:begin x:=x+2;y:=y-2;end;
      kierSW:begin x:=x-2;y:=y+2;end;
      kierSE:begin x:=x+2;y:=y+2;end;
     end;
  end;
  //kolizja z graczem- tu akcja odbij
  if (Sprite is TGracz) then begin
     if TGracz(Sprite).fKolizja then exit;
     TGracz(Sprite).fKolizja:=true;
     kierunek:=KierunekPoKolizji(colX,colY);
     dVa:=0;//prdko animacj na czas zderzenia wyzeruj;
     case kierunek of
      kierNW:begin x:=x-1;y:=y-1;end;
      kierNE:begin x:=x+1;y:=y-1;end;
      kierSW:begin x:=x-1;y:=y+1;end;
      kierSE:begin x:=x+1;y:=y+1;end;
     end;
  end;
end;

procedure TStwor.MoznaIsc(const Value:single);
var
 stKierunek:tkierunek;
begin

 stareX:=x;
 stareY:=y;
 case kierunek of
      kierN  : kierunekN (2*Value);
      kierNE : kierunekNE(2*Value);
      kierE  : kierunekE (2*Value);
      kierSE : kierunekSE(2*Value);
      kierS  : kierunekS (2*Value);
      kierSW : kierunekSW(2*Value);
      kierW  : kierunekW (2*Value);
      kierNW : kierunekNW(2*Value);
 end;
 x:=x+Skok_X;
 y:=y+Skok_Y;
 JakaKostka;
 x:=stareX;
 y:=stareY;
 if(Drogi[wd,kd]>-1)then begin
   dVA:=0;
   Odbicie;
   Skok_X:=0;
   Skok_Y:=0;
   exit;//wyskocz z calej procedury
 end;

 IDAnimacji:=IDAnimacji+dVA*Value;//dVA to predkosc animacji
 if IDAnimacji>2 then IDAnimacji:=0;
 ImageIndex:=Round(IDAnimacji+OfsetKlatki);
 dVA:=7;//ponownie przypis zpredkosc animacji bo istnieja funkcj ektore ja zeruja
        //podcza skolizji- zmniajsz to migotanie

 x:=x+Skok_X;
 y:=y+Skok_Y;
end;
procedure TStwor.Draw;
begin
  //UWAGA - Jeeli jest wicej budynkw ni jeden to nalezy je rozrniac
 // tak aby Gracz puls inny duszek byli widoczni w siatce tego samego budynku
 // inaczej mwic inny duszek tez ma byc wrazliwy na zman siatek
 visible:=true;
 if (TGracz(Gracz).fWBudynku=true)and(fWBudynku) then inherited Draw
 else if (TGracz(Gracz).fWBudynku=false)and(fWBudynku=false)then
 begin
   if (TGracz(Gracz).fWBudynku=true)and(fWBudynku=false)then begin visible:=false;exit;end;
   if not fPokryty then inherited Draw
   else
    Image.Draw(Round(x),Round(y),0,0.5,0.5,1,1,2,0,255,150,ImageIndex,0);

 end;
end;
procedure TStwor.Move(const MoveCount:single);
begin
 //dodatkowy test sprawdzajacy czy jest poza budynkiem
 if ((x<9)or(x>15)or(y<6)or(y>12))and(TGracz(Gracz).fwBudynku=false)then fWBudynku:=false;
 //przesun bo przesunieto swiat
 x:=x+SkokX;
 y:=y+SkokY;
 BufordV:=MoveCount;
 MoznaIsc(MoveCount);
 fKolizja:=false;
 fPokryty:=false;
 //najprostszy z mozliwych warunek trzymania stworw w obrebie mapy
 if x<Warstwa0[0, 0].x then  kierunek:=kierE;
 if x>Warstwa0[0,18].x then  kierunek:=kierW;
 if y<Warstwa0[0, 0].y then  kierunek:=kierS;
 if y>Warstwa0[19,0].y then  kierunek:=kierN;
end;
//

//******Koniec klast TStwor************
procedure TworzBorostwora( const Ax,Ay:integer;
                           const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                           const IdKlatka:Integer//indeks wycinanej klatki);
                           );
begin
 with TStwor.Create(AParent,ImageListItem,IdKlatka) do
 begin
 Name:=IntToStr(AParent.Count-1);
 dVA:=7;// predkosc animacji klatek
 X:=Ax;
 Y:=Ay;
 //losuj poczatkowy kierunek ruchu stwora

 kierunek:=tKierunek(Ord(Random(7)));
 //Odbicie;
 case Kierunek of
          kierN  :kierunekN (1/25);
          kierNE :kierunekNE(1/25);
          kierE  :kierunekE (1/25);
          kierSE :kierunekSE(1/25);
          kierS  :kierunekS (1/25);
          kierSW :kierunekSW(1/25);
          kierW  :kierunekW (1/25);
          kierNW :kierunekNW(1/25);
 end;

 end;
end;
procedure TStwor.Odbicie;
     //funkcje mozliwych odbic
     //uderzenie z N
     function zkierunkuN:tKierunek;
     const
      {ukad: NW N NE
              W  X  E}
      ukalKierunk:array[0..4]of tKierunek=(kierNW,kierN,kierNE,kierW,kierE);
      t:array[0..4,0..1]of integer=((-1,-1),(-1, 0),(-1, 1),
                                    ( 0,-1),        (0 , 1));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     //uderzenie z S
     function zkierunkuS:tKierunek;
     const
      {ukad: W   X  E
              SW  S SE}
      ukalKierunk:array[0..4]of tKierunek=(kierW,kierE,kierSW,kierS,kierSE);
      t:array[0..4,0..1]of integer=(( 0,-1),        (0, 1),
                                    ( 1,-1),( 1, 0),(1, 1));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     function zkierunkuW:tKierunek;
     const
      {ukad: NW N
              W  X
              SW S}
      ukalKierunk:array[0..4]of tKierunek=(kierNW,kierN,kierW,kierSW,kierS);
      t:array[0..4,0..1]of integer=((-1,-1),(-1, 0),
                                    ( 0,-1),
                                    ( 1,-1),( 1, 0));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     function zkierunkuE:tKierunek;
     const
      {ukad: N  NE
              X   E
              S SE}
      ukalKierunk:array[0..4]of tKierunek=(kierN,kierNE,kierE,kierS,kierSE);
      t:array[0..4,0..1]of integer=((-1, 0),(-1, 1),
                                            ( 0, 1),
                                    ( 1, 0),( 1, 1));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     function zkierunkuNW:tKierunek;
     const
      {ukad: NW  N  NE
              W       E
              SW  S   X  }
      ukalKierunk:array[0..6]of tKierunek=(kierNW,kierN,kierNE,kierW,kierE,kierSW,kierS);
      t:array[0..6,0..1]of integer=((-1,-1),(-1, 0),(-1, 1),
                                    ( 0,-1),        ( 0, 1),
                                    ( 1,-1),( 1, 0));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     function zkierunkuNE:tKierunek;
     const
      {ukad: NW  N  NE
              W       E
              X  S   SE  }
      ukalKierunk:array[0..6]of tKierunek=(kierNW,kierN,kierNE,kierW,kierE,kierSE,kierS);
      t:array[0..6,0..1]of integer=((-1,-1),(-1, 0),(-1, 1),
                                    ( 0,-1),        ( 0, 1),
                                            ( 1, 0),( 1, 1));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     function zkierunkuSE:tKierunek;
     const
      {ukad: X   N  NE
              W       E
              SW S   SE  }
      ukalKierunk:array[0..6]of tKierunek=(kierN,kierNE,kierW,kierE,kierSW,kierS,kierSE);
      t:array[0..6,0..1]of integer=(        (-1, 0),(-1, 1),
                                    ( 0,-1),        ( 0, 1),
                                    ( 1,-1),( 1, 0),( 1, 1));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
     function zkierunkuSW:tKierunek;
     const
      {ukad: NW   N  X
              W       E
              SW S   SE  }
      ukalKierunk:array[0..6]of tKierunek=(kierNW,kierN,kierW,kierE,kierSW,kierS,kierSE);
      t:array[0..6,0..1]of integer=((-1,-1),(-1, 0),
                                    ( 0,-1),        ( 0, 1),
                                    ( 1,-1),( 1, 0),( 1, 1));
     var
      //tablica mozliwych kierunkw
      tabKier:array of tKierunek;
      _k,_w:integer;
      i,r:byte;
     begin
      r:=1;
      setLength(tabKier,r);
      for i:=0 to 4 do begin
          _w:=stareWD+t[i,0];if _w<0 then _w:=0;if _w>19 then _w:=19;
          _k:=stareKD+t[i,1];if _w<0 then _k:=0;if _k>19 then _k:=19;
          if Drogi[_w,_k]=-1 then begin
             tabKier[high(tabKier)]:=ukalKierunk[i];
             inc(r);
             setLength(tabKier,r);
          end;
      end;
      //wylosuj dostepny kierunek
      result:=tabKier[Random(high(tabKier)+1)-1];//[Random(high(tabKier))];
      tabKier:=nil;
     end;
//koniec wbudowanych funkcji uderze

begin

  case Kierunek of
      kierN  : kierunek:=zKierunkuN;
      kierNE : kierunek:=zKierunkuNE;
      kierE  : kierunek:=zKierunkuE;
      kierSE : kierunek:=zKierunkuSE;
      kierS  : kierunek:=zKierunkuS;
      kierSW : kierunek:=zKierunkuSW;
      kierW  : kierunek:=zKierunkuW;
      kierNW : kierunek:=zKierunkuNW;
  end;
end;
end.

